#define WIN32_LEAN_AND_MEAN

//---------------------------------------------------------------------------
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include <alloc.h>

#define HWND unsigned long
#define BOOL bool

//#define _loaded_

#ifdef _loaded_
typedef struct{
 DWORD mVersion;
 HWND mHwnd;
 BOOL mKeep;
} LOADINFO;

extern "C" __declspec(dllexport) void __stdcall LoadDll(LOADINFO *ld)
{
 //---
}
//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) int __stdcall UnloadDLL(int mTimeout)
{
 //---
 return 1;
}
//---------------------------------------------------------------------------
#endif

extern "C" __declspec(dllexport) int __stdcall tblit(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
 char f1[100], f2[100];
 int perc;
 if (sscanf(data, "%s %s %d", f1, f2, &perc) != 3) {
   sprintf(data, "ERR: insufficient parameters");
   return 3;
 }
 if (perc<0) perc=0;
 else if (perc>100) perc=100;

 int fh=open(f1,O_RDONLY|O_BINARY);
 if (fh == -1) {
   sprintf(data, "ERR: unable to open file '%s'...", f1);
   return 3;
 }
 int len=lseek(fh,0,SEEK_END);
 char *file1=(char*)malloc(len);
 lseek(fh,0,SEEK_SET);
 read(fh, file1, len);
 close(fh);

 if (!(file1[0] == 'B' && file1[1] == 'M')) {
   free(file1);
   sprintf(data, "ERR: file '%s' is not a Bitmap...", f1);
   return 3;
 }

 fh=open(f2,O_RDONLY|O_BINARY);
 if (fh == -1) {
   free(file1);
   sprintf(data, "ERR: unable to open file '%s'...", f2);
   return 3;
 }
 len=lseek(fh,0,SEEK_END);
 char *file2=(char*)malloc(len);
 lseek(fh,0,SEEK_SET);
 read(fh, file2, len);
 close(fh);

 if (!(file2[0] == 'B' && file2[1] == 'M')) {
   free(file1);
   free(file2);
   sprintf(data, "ERR: file '%s' is not a Bitmap...", f2);
   return 3;
 }

 if (((long*)&file1[18])[0] != ((long*)&file2[18])[0] ||
     ((long*)&file1[22])[0] != ((long*)&file2[22])[0] ||
     ((short*)&file1[28])[0] != ((short*)&file2[28])[0] ) {
   free(file1);
   free(file2);
   sprintf(data, "ERR: Bitmap-dimensions/bitdepth don't match or corrupt files...");
   return 3;
 }

 if (((short*)&file1[28])[0] == 24 || ((short*)&file1[28])[0] == 32) {
   unsigned char *p1=file1+54, *p2=file2+54;
   unsigned char *maxp=file1+len;
   while (p1<maxp) {
     p1[0]=(p1[0]*(100-perc)+p2[0]*perc)/100;
     p1++;
     p2++;
   }
 }
 else if (((short*)&file1[28])[0] == 16) {
   unsigned short *p1=(unsigned short*)file1+27, *p2=(unsigned short*)file2+27;
   unsigned short *maxp=(unsigned short*)file1+(len>>1);
   unsigned char r, g, b;
   while (p1<maxp) {
     r=((p1[0]>>10)*(100-perc)+(p2[0]>>10)*perc)/100;
     g=(((p1[0]>>5)&31)*(100-perc)+((p2[0]>>5)&31)*perc)/100;
     b=((p1[0]&31)*(100-perc)+(p2[0]&31)*perc)/100;
     p1[0]=((r&63)<<10)+((g&31)<<5)+(b&31);
     p1++;
     p2++;
   }
 }
 else {
   free(file1);
   free(file2);
   sprintf(data, "ERR: unsupported bitdepth");
   return 3;
 }

 fh=open("tblit.bmp",O_CREAT|O_TRUNC|O_BINARY|O_WRONLY, S_IREAD|S_IWRITE);
 write(fh,file1,len);
 close(fh);

 free(file1);
 free(file2);
 sprintf(data, "OK: .");
 return 3;
}
//---------------------------------------------------------------------------


